<?php
namespace nur\sery\schema\input;

#XXX available permet de préciser qu'une valeur doit exister et être non vide
# pour être considérée. en faire un paramètre, à moins que ce soit au niveau du
# type qu'il faille le gérer?
/**
 * Class Input: accès à une valeur
 *
 * cette implémentation lit depuis et écrit dans une référence
 */
class Input {
  function __construct(&$dest=null) {
    $this->dest =& $dest;
  }

  protected $dest;

  /** tester si la valeur existe */
  function exists($key=null): bool {
    if ($key === null) return true;
    return $this->dest !== null && array_key_exists($key, $this->dest);
  }

  function get($key=null) {
    if ($key === null) return $this->dest;
    elseif ($this->dest === null) return null;
    elseif (!array_key_exists($key, $this->dest)) return null;
    else return $this->dest[$key];
  }

  function set($value, $key=null): void {
    if ($key === null) $this->dest = $value;
    else $this->dest[$key] = $value;
  }
}
